build:
  stage: Building
  tags:
    - harmony-infrastructure
  script:
    - '$versionGroup = git describe --tags --long | Select-String -Pattern "(?<major>[0-9]+)\.(?<minor>[0-9]*)\.(?<patch>[0-9]*)\-(?<commit>[0-9]+)\-g[0-9a-f]+" | Select-Object -First 1'
    - '[int]$major, [int]$minor, [int]$patch, [int]$commit = $versionGroup.Matches[0].Groups["major", "minor", "patch", "commit"].Value'
    - '$FILE_VERSION = "$major.$minor.$patch.$commit"'
    - '$SOFT_VERSION = "$major.$minor.$patch"'
    - 'echo $FILE_VERSION'
    - 'Add-Content -Path build.env -Value "FILE_VERSION=$FILE_VERSION"'
    - 'echo $SOFT_VERSION'
    - 'Add-Content -Path build.env -Value "SOFT_VERSION=$SOFT_VERSION"'
    - 'dotnet build "sources/Harmony.Infrastructure.Common.sln" --configuration Release -p:Version=$FILE_VERSION'
  artifacts:
    reports:
      dotenv: build.env

test:
  stage: Testing
  tags:
    - harmony-infrastructure
  variables:
    GIT_CLEAN_FLAGS: "none"
  cache: {}
  needs:
    - job: build
      artifacts: false
  script:
    - 'dotnet test "tests/Common.UnitTests/Common.UnitTests.csproj" --configuration Release --no-build --logger trx'
  artifacts:
    name: "test-report"
    public: true
    paths:
      - "tests/Common.UnitTests/TestResults/*.trx"

publish:
  stage: Publishing
  tags:
    - harmony-infrastructure
  variables:
    GIT_CLEAN_FLAGS: "none"
  cache: {}
  needs:
    - job: build
      artifacts: true
    - job: test
      artifacts: false
  script:
    - 'echo $VERSION'
    - 'dotnet pack "sources/Common/Common.csproj" --configuration Release --no-build -p:Version=$SOFT_VERSION'
  artifacts:
    name: "nupkg"
    public: true
    paths:
      - "sources/Common/bin/Release/Harmony.Infrastructure.Common.$SOFT_VERSION.nupkg"

deploy:
  stage: Deploying
  tags:
    - harmony-infrastructure
  variables:
    GIT_CLEAN_FLAGS: "none"
  cache: {}
  needs:
    - job: build
      artifacts: true
    - job: publish
      artifacts: false
  script:
    - 'echo $VERSION'
    - 'echo $NUGET_UPLOAD_KEY'
    - 'dotnet nuget push "sources/Common/bin/Release/Harmony.Infrastructure.Common.$SOFT_VERSION.nupkg" -s "https://api.nuget.org/v3/index.json" -k $NUGET_UPLOAD_KEY'
  rules:
    - if: '$CI_COMMIT_TAG =~ /^v.*/'

# get-logs:
#   stage: Cleaning
#   tags:
#     - harmony-infrastructure
#   variables:
#     GIT_CLEAN_FLAGS: "none"
#   cache: {}
#   needs:
    # - job: build
    #   artifacts: true
#   script:
#     - 'Get-EventLog -LogName Application -Newest 15 |select eventid,machinename,entrytype,message,source,timegenerated,username'
#   when: on_failure
